require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Intent"
import "android.content.Context"
import "java.io.File"
import "android.net.Uri"

local C = {} local pth = this.getLuaDir().."/contacts" local fP = pth .. "/contacts_data"

local dir = File(pth)
if not dir.exists() then
    dir.mkdirs()
end

local function rc(t, p)     local f, err = io.open(p, "r")
    if err ~= nil then
        f = io.open(p, "w")
    else
        for ln in io.lines(p) do
            local s = string.gsub(ln, '\\n', '\n')
            table.insert(t, s)
        end
        f:close()
    end
end

local function wc(t, p)     local f = io.open(p, 'w')
    for _, v in ipairs(t) do
        f:write(string.gsub(v, '\n', '\\n')..'\n')
    end
    f:close()
end

local function mv(t, k, iK)         if k >= #t or k == 0 and iK == 0 then
        return
    end

    local s = t[k + 1]
    if iK == 0 then         table.insert(t, 1, s)
        table.remove(t, k + 2)
    elseif iK == 1 then         table.remove(t, k + 1)
    end
end

local lytE = {     LinearLayout,
    orientation = "vertical",
    {
        EditText,
        id = "nmF",         hint = "Enter name"
    },
    {
        EditText,
        id = "noF",         hint = "Enter phone number"
    }
}

local ed = loadlayout(lytE)
local nmF = ed.getChildAt(0)
local noF = ed.getChildAt(1)

local et = LuaDialog()
et.setTitle("Add Contact")
et.setView(ed)
et.setButton("OK", function()
    local nm = nmF.getText().toString()
    local no = noF.getText().toString()
    if nm ~= '' and no ~= '' then
        table.insert(C, nm .. " - " .. no)
        nmF.setText('')
        noF.setText('')
        wc(C, fP)
    end
    grid.adapter = SingleLineAdapter(service, String(C))
    dlg.show()
end)

local help = LuaDialog(service)
help.setTitle("Contacts")
help.setMessage("This is a contacts extension. You can store and manage contacts. To add a new contact, press the add button, enter the name and phone number, then press OK.")
help.setButton("Close", function()
    dlg.show()
end)

local mI = {
    "Move to top",
    "Delete selected contact",
}
local dlgM = LuaDialog(service)
dlgM.setItems(mI)

local lyt = {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill"
}

dlg = LuaDialog(service)
dlg.View = loadlayout(lyt)
rc(C, fP)
grid.adapter = SingleLineAdapter(service, String(C))
dlg.setButton("Close")
dlg.setButton2("Add", function(v)
    task(50, function()
        et.show()
    end)
end)
dlg.setButton3("Help", function(v)
    help.show()
end)

dlg.show()

grid.onItemClick = function(l, v)
    local no = v.text:match("%- (.+)$")
    if no then
        service.callPhone(no)
        dlg.dismiss()
    end
end

grid.onItemLongClick = function(l, v, p, i)
    dlg.dismiss()
    local vib = this.getSystemService(Context.VIBRATOR_SERVICE)
    vib.vibrate(long{50, 30}, -1)
    dlgM.show()
    dlgM.onItemClick = function(_, _, iK)
        dlgM.dismiss()
        mv(C, i, iK)
        wc(C, fP)
                grid.adapter = SingleLineAdapter(service, String(C))
        dlg.show()
    end
end